blog/urls.py
# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.conf.urls import url

from . import views

urlpatterns = [
    url(r'^$', views.IndexView.as_view(), name='index'),
    url(r'^post/(?P<pk>[0-9]+)/$', views.PostDetailView.as_view(), name='detail'),
    url(r'^archives/(?P<year>[0-9]{4})/(?P<month>[0-9]{1,2})/$', views.ArchivesView.as_view(), name='archives'),
    url(r'^category/(?P<pk>[0-9]+)/$', views.CategoryView.as_view(), name='category'),
    url(r'^tag/(?P<pk>[0-9]+)/$', views.TagView.as_view(), name='tag'),
    url(r'^search/$', views.search, name='search'),
]

blogproject/urls.py
from django.conf.urls import url, include
from django.contrib import admin

from blog.feeds import AllPostsRssFeed

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'', include('blog.urls', namespace='blog')),
    url(r'', include('comments.urls', namespace='comments')),
    url(r'^all/rss/$', AllPostsRssFeed(), name='rss'),
]

comments/urls.py
#!/usr/bin/python
# -*- coding: utf-8 -*-

from django.conf.urls import  url

from . import views

urlpatterns = [
    url(r'^comment/post/(?P<post_pk>[0-9]+)/$', views.post_comment, name='post_comment'),
]

blog/models.py
# -*- coding: utf-8 -*-
from __future__ import unicode_literals

import markdown
from django.db import models
from django.utils.encoding import python_2_unicode_compatible
from django.contrib.auth.models import User
from django.urls import reverse
from django.utils.html import strip_tags


@python_2_unicode_compatible
class Category(models.Model):
    name = models.CharField(max_length=100)

    def __str__(self):
        return self.name


@python_2_unicode_compatible
class Tag(models.Model):
    name = models.CharField(max_length=100)

    def __str__(self):
        return self.name

@python_2_unicode_compatible
class Post(models.Model):
    title = models.CharField(max_length=70)

    body = models.TextField()

    created_time = models.DateTimeField()
    modified_time = models.DateTimeField()

    excerpt = models.CharField(max_length=200, blank=True)

    category = models.ForeignKey(Category)
    tags = models.ManyToManyField(Tag, blank=True)

    author = models.ForeignKey(User)

    views = models.PositiveIntegerField(default=0)

    def __str__(self):
        return self.title

    def get_absolute_url(self):
        return reverse('blog:detail', kwargs={'pk': self.pk})

    def increase_views(self):
        self.views += 1
        self.save(update_fields=['views'])

    def save(self, *args, **kwargs):
        if not self.excerpt:
            md = markdown.Markdown(extensions=[
                'markdown.extensions.extra',
                'markdown.extensions.codehilite',
            ])
            self.excerpt = strip_tags(md.convert((self.body)))[:54]

        super(Post, self).save(*args, **kwargs)

    class Meta:
        ordering = ['-created_time']

comments/models.py
# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.db import models
from django.utils.encoding import python_2_unicode_compatible


@python_2_unicode_compatible
class Comment(models.Model):
    name = models.CharField(max_length=100)
    email = models.EmailField(max_length=255)
    url = models.URLField(blank=True)
    text = models.TextField()
    created_time = models.DateTimeField(auto_now_add=True)

    post = models.ForeignKey("blog.Post")

    def __str__(self):
        return self.text[:20]

blog/views.py
# -*- coding: utf-8 -*-
from __future__ import unicode_literals

import markdown
from django.shortcuts import render, get_object_or_404
from django.views.generic import ListView, DetailView
from django.db.models import Q

from .models import Post, Category, Tag
from comments.forms import CommentForm


class IndexView(ListView):
    model = Post
    template_name = 'blog/index.html'
    context_object_name = 'post_list'
    paginate_by = 5

    def get_context_data(self, **kwargs):
        """
        在视图函数中将模板变量传递给模板是通过给 render 函数的 context 参数传递一个字典实现的，
        例如 render(request, 'blog/index.html', context={'post_list': post_list})，
        这里传递了一个 {'post_list': post_list} 字典给模板。
        在类视图中，这个需要传递的模板变量字典是通过 get_context_data 获得的，
        所以我们复写该方法，以便我们能够自己再插入一些我们自定义的模板变量进去。
        """

        # 首先获得父类生成的传递给模板的字典。
        context = super(IndexView, self).get_context_data(**kwargs)

        # 父类生成的字典中已有 paginator、page_obj、is_paginated 这三个模板变量，
        # paginator 是 Paginator 的一个实例，
        # page_obj 是 Page 的一个实例，
        # is_paginated 是一个布尔变量，用于指示是否已分页。
        # 例如如果规定每页 10 个数据，而本身只有 5 个数据，其实就用不着分页，此时 is_paginated=False。
        # 关于什么是 Paginator，Page 类在 Django Pagination 简单分页：http://zmrenwu.com/post/34/ 中已有详细说明。
        # 由于 context 是一个字典，所以调用 get 方法从中取出某个键对应的值。
        paginator = context.get('paginator')
        page = context.get('page_obj')
        is_paginated = context.get('is_paginated')

        # 调用自己写的 pagination_data 方法获得显示分页导航条需要的数据，见下方。
        pagination_data = self.pagination_data(paginator, page, is_paginated)

        # 将分页导航条的模板变量更新到 context 中，注意 pagination_data 方法返回的也是一个字典。
        context.update(pagination_data)

        # 将更新后的 context 返回，以便 ListView 使用这个字典中的模板变量去渲染模板。
        # 注意此时 context 字典中已有了显示分页导航条所需的数据。
        return context

    def pagination_data(self, paginator, page, is_paginated):
        if not is_paginated:
            # 如果没有分页，则无需显示分页导航条，不用任何分页导航条的数据，因此返回一个空的字典
            return {}

        # 当前页左边连续的页码号，初始值为空
        left = []

        # 当前页右边连续的页码号，初始值为空
        right = []

        # 标示第 1 页页码后是否需要显示省略号
        left_has_more = False

        # 标示最后一页页码前是否需要显示省略号
        right_has_more = False

        # 标示是否需要显示第 1 页的页码号。
        # 因为如果当前页左边的连续页码号中已经含有第 1 页的页码号，此时就无需再显示第 1 页的页码号，
        # 其它情况下第一页的页码是始终需要显示的。
        # 初始值为 False
        first = False

        # 标示是否需要显示最后一页的页码号。
        # 需要此指示变量的理由和上面相同。
        last = False

        # 获得用户当前请求的页码号
        page_number = page.number

        # 获得分页后的总页数
        total_pages = paginator.num_pages

        # 获得整个分页页码列表，比如分了四页，那么就是 [1, 2, 3, 4]
        page_range = list(paginator.page_range)

        if page_number == 1:
            # 如果用户请求的是第一页的数据，那么当前页左边的不需要数据，因此 left=[]（已默认为空）。
            # 此时只要获取当前页右边的连续页码号，
            # 比如分页页码列表是 [1, 2, 3, 4]，那么获取的就是 right = [2, 3]。
            # 注意这里只获取了当前页码后连续两个页码，你可以更改这个数字以获取更多页码。
            right = page_range[page_number:page_number + 2]

            # 如果最右边的页码号比最后一页的页码号减去 1 还要小，
            # 说明最右边的页码号和最后一页的页码号之间还有其它页码，因此需要显示省略号，通过 right_has_more 来指示。
            if right[-1] < total_pages - 1:
                right_has_more = True

            # 如果最右边的页码号比最后一页的页码号小，说明当前页右边的连续页码号中不包含最后一页的页码
            # 所以需要显示最后一页的页码号，通过 last 来指示
            if right[-1] < total_pages:
                last = True

        elif page_number == total_pages:
            # 如果用户请求的是最后一页的数据，那么当前页右边就不需要数据，因此 right=[]（已默认为空），
            # 此时只要获取当前页左边的连续页码号。
            # 比如分页页码列表是 [1, 2, 3, 4]，那么获取的就是 left = [2, 3]
            # 这里只获取了当前页码后连续两个页码，你可以更改这个数字以获取更多页码。
            left = page_range[(page_number - 3) if (page_number - 3) > 0 else 0:page_number - 1]

            # 如果最左边的页码号比第 2 页页码号还大，
            # 说明最左边的页码号和第 1 页的页码号之间还有其它页码，因此需要显示省略号，通过 left_has_more 来指示。
            if left[0] > 2:
                left_has_more = True

            # 如果最左边的页码号比第 1 页的页码号大，说明当前页左边的连续页码号中不包含第一页的页码，
            # 所以需要显示第一页的页码号，通过 first 来指示
            if left[0] > 1:
                first = True
        else:
            # 用户请求的既不是最后一页，也不是第 1 页，则需要获取当前页左右两边的连续页码号，
            # 这里只获取了当前页码前后连续两个页码，你可以更改这个数字以获取更多页码。
            left = page_range[(page_number - 3) if (page_number - 3) > 0 else 0:page_number - 1]
            right = page_range[page_number:page_number + 2]

            # 是否需要显示最后一页和最后一页前的省略号
            if right[-1] < total_pages - 1:
                right_has_more = True
            if right[-1] < total_pages:
                last = True

            # 是否需要显示第 1 页和第 1 页后的省略号
            if left[0] > 2:
                left_has_more = True
            if left[0] > 1:
                first = True

        data = {
            'left': left,
            'right': right,
            'left_has_more': left_has_more,
            'right_has_more': right_has_more,
            'first': first,
            'last': last,
        }

        return data


class CategoryView(ListView):
    model = Post
    template_name = 'blog/index.html'
    context_object_name = 'post_list'

    def get_queryset(self):
        cate = get_object_or_404(Category, pk=self.kwargs.get('pk'))
        return super(CategoryView, self).get_queryset().filter(category=cate)


class TagView(ListView):
    model = Post
    template_name = 'blog/index.html'
    context_object_name = 'post_list'

    def get_queryset(self):
        tag = get_object_or_404(Tag, pk=self.kwargs.get('pk'))
        return super(TagView, self).get_queryset().filter(tags=tag)


class ArchivesView(ListView):
    model = Post
    template_name = 'blog/index.html'
    context_object_name = 'post_list'

    def get_queryset(self):
        year = self.kwargs.get('year')
        month = self.kwargs.get('month')
        return super(ArchivesView, self).get_queryset().filter(
            created_time__year=year,
            created_time__month=month
        )


class PostDetailView(DetailView):
    model = Post
    template_name = 'blog/detail.html'
    context_object_name = 'post'

    def get(self, request, *args, **kwargs):
        response = super(PostDetailView, self).get(request, *args, **kwargs)

        self.object.increase_views()

        return response

    def get_object(self, queryset=None):
        post = super(PostDetailView, self).get_object(queryset=None)
        md = markdown.Markdown(extensions=[
            'markdown.extensions.extra',
            'markdown.extensions.codehilite',
            'markdown.extensions.toc',
        ])
        post.body = md.convert(post.body)
        post.toc = md.toc
        return post

    def get_context_data(self, **kwargs):
        context = super(PostDetailView, self).get_context_data(**kwargs)
        form = CommentForm()
        comment_list = self.object.comment_set.all()
        context.update({
            'form': form,
            'comment_list': comment_list
        })
        return context


def search(request):
    q = request.GET.get('q')
    error_msg = ''

    if not q:
        error_msg = "请输入关键词"
        return render(request, 'blog/index.html', { 'error_msg': error_msg })

    post_list = Post.objects.filter(Q(title__icontains=q) | Q(body__icontains=q))
    return render(request, 'blog/index.html', {
        'error_msg': error_msg,
        'post_list': post_list
    })

templates/blog/detail.html
{% extends 'base.html' %}

{% block main %}
<article class="post post-{{ post.pk }}">
    <header class="entry-header">
        <h1 class="entry-title">{{ post.title }}</h1>
        <div class="entry-meta">
            <span class="post-category"><a href="#">{{ post.category.name }}</a></span>
            <span class="post-date"><a href="#"><time class="entry-date"
                                                      datetime="{{ post.created_time }}">{{ post.created_time }}</time></a></span>
            <span class="post-author"><a href="#">{{ post.author }}</a></span>
            <span class="comments-link"><a href="#">4 评论</a></span>
            <span class="views-count"><a href="#">{{ post.views }} 阅读</a></span>
        </div>
    </header>
    <div class="entry-content clearfix">
        {{ post.body | safe }}
    </div>
</article>
<section class="comment-area" id="comment-area">
    <hr>
    <h3>发表评论</h3>
    <form action="{% url 'comments:post_comment' post.pk %}" method="post" class="comment-form">
        {% csrf_token %}
        <div class="row">
            <div class="col-md-4">
                <label for="{{ form.name.id_for_label }}">名字：</label>
                {{ form.name }}
                {{ form.name.errors }}
            </div>
            <div class="col-md-4">
                <label for="{{ form.email.id_for_label }}">邮箱：</label>
                {{ form.email }}
                {{ form.email.errors }}
            </div>
            <div class="col-md-4">
                <label for="{{ form.url.id_for_label }}">URL：</label>
                {{ form.url }}
                {{ form.url.errors }}
            </div>
            <div class="col-md-12">
                <label for="{{ form.text.id_for_label }}">评论：</label>
                {{ form.text }}
                {{ form.text.errors }}
                <button type="submit" class="comment-btn">发表</button>
            </div>
        </div>    <!-- row -->
    </form>
    <div class="comment-list-panel">
        <h3>评论列表，共 {{ post.comment_set.count }} 条评论</h3>
        <ul class="comment-list list-unstyled">
            {% for comment in comment_list %}
            <li class="comment-item">
                <span class="nickname">{{ comment.name }}</span>
                <time class="submit-date">{{ comment.created_time }}</time>
                <div class="text">
                    {{ comment.text }}
                </div>
            </li>
            {% empty %}
            暂无评论
            {% endfor %}
        </ul>
    </div>
</section>
{% endblock main %}

{% block toc %}
<div class="widget widget-content">
    <h3 class="widget-title">文章目录</h3>
    {{ post.toc | safe}}
</div>
{% endblock toc %}

templates/blog/index.html
{% extends 'base.html' %}

{% block main %}

{% if error_msg %}
<p>{{ error_msg }}</p>
{% endif %}

{% for post in post_list %}
<article class="post post-{{ post.pk }}">
    <header class="entry-header">
        <h1 class="entry-title">
            <a href="{{ post.get_absolute_url }}">{{ post.title }}</a>
        </h1>
        <div class="entry-meta">
            <span class="post-category"><a href="#">{{ post.category.name }}</a></span>
            <span class="post-date"><a href="#"><time class="entry-date"
                                                      datetime="{{ post.created_time }}">{{ post.created_time }}</time></a></span>
            <span class="post-author"><a href="#">{{ post.author }}</a></span>
            <span class="comments-link"><a href="#">{{ post.comment_set.count }} 评论</a></span>
            <span class="views-count"><a href="{{ post.get_absolute_url }}">{{ post.views }} 阅读</a></span>
        </div>
    </header>
    <div class="entry-content clearfix">
        <p>{{ post.excerpt }}...</p>
        <div class="read-more cl-effect-14">
            <a href="{{ post.get_absolute_url }}" class="more-link">继续阅读 <span class="meta-nav">→</span></a>
        </div>
    </div>
</article>
{% empty %}
<div class="no-post">no post.</div>
{% endfor %}

{% if is_paginated %}
<div class="pagination">
    {% if first %}
    <a href="?page=1">1</a>
    {% endif %}
    {% if left %}
    {% if left_has_more %}
    <span>...</span>
    {% endif %}
    {% for i in left %}
    <a href="?page={{ i }}">{{ i }}</a>
    {% endfor %}
    {% endif %}
    <a href="?page={{ page_obj.number }}" style="color: red">{{ page_obj.number }}</a>
    {% if right %}
    {% for i in right %}
    <a href="?page={{ i }}">{{ i }}</a>
    {% endfor %}
    {% if right_has_more %}
    <span>...</span>
    {% endif %}
    {% endif %}
    {% if last %}
    <a href="?page={{ paginator.num_pages }}">{{ paginator.num_pages }}</a>
    {% endif %}
</div>
{% endif %}

{% endblock main %}